require '_h2ph_pre.ph';

no warnings qw(redefine misc);

if(!defined (&_SYS_STAT_H)  && !defined (&_FCNTL_H)) {
    die("Never include <bits/stat.h> directly; use <sys/stat.h> instead.");
}
unless(defined(&_BITS_STAT_H)) {
    eval 'sub _BITS_STAT_H () {1;}' unless defined(&_BITS_STAT_H);
    require 'bits/endian.ph';
    require 'bits/wordsize.ph';
    eval 'sub _STAT_VER_KERNEL () {0;}' unless defined(&_STAT_VER_KERNEL);
    eval 'sub _STAT_VER_LINUX () {0;}' unless defined(&_STAT_VER_LINUX);
    eval 'sub _STAT_VER () { &_STAT_VER_KERNEL;}' unless defined(&_STAT_VER);
    eval 'sub _MKNOD_VER_LINUX () {0;}' unless defined(&_MKNOD_VER_LINUX);
    if(defined (&__USE_FILE_OFFSET64)) {
	eval 'sub __field64 {
	    my($type, $type64, $name) = @_;
    	    eval q($type64 $name);
	}' unless defined(&__field64);
    }
 elsif((defined(&__WORDSIZE) ? &__WORDSIZE : undef) == 64|| defined (&__INO_T_MATCHES_INO64_T)) {
	if(defined (&__INO_T_MATCHES_INO64_T)  && !defined (&__OFF_T_MATCHES_OFF64_T)) {
	    die("ino_t and off_t must both be the same type");
	}
	eval 'sub __field64 {
	    my($type, $type64, $name) = @_;
    	    eval q($type $name);
	}' unless defined(&__field64);
    }
 elsif((defined(&__BYTE_ORDER) ? &__BYTE_ORDER : undef) == (defined(&__LITTLE_ENDIAN) ? &__LITTLE_ENDIAN : undef)) {
	eval 'sub __field64 {
	    my($type, $type64, $name) = @_;
    	    eval q($type $name  &__attribute__(( &__aligned__ ( &__alignof__ ($type64)))); \'int\'  &__$name &_pad);
	}' unless defined(&__field64);
    } else {
	eval 'sub __field64 {
	    my($type, $type64, $name) = @_;
    	    eval q(\'int\'  &__$name &_pad  &__attribute__(( &__aligned__ ( &__alignof__ ($type64)))); $type $name);
	}' unless defined(&__field64);
    }
    if(defined(&__USE_XOPEN2K8)) {
	eval 'sub st_atime () { ($st_atim->{tv_sec});}' unless defined(&st_atime);
	eval 'sub st_mtime () { ($st_mtim->{tv_sec});}' unless defined(&st_mtime);
	eval 'sub st_ctime () { ($st_ctim->{tv_sec});}' unless defined(&st_ctime);
    } else {
    }
    undef(&__field64) if defined(&__field64);
    if(defined(&__USE_LARGEFILE64)) {
	if(defined(&__USE_XOPEN2K8)) {
	} else {
	}
    }
    eval 'sub _STATBUF_ST_BLKSIZE () {1;}' unless defined(&_STATBUF_ST_BLKSIZE);
    eval 'sub _STATBUF_ST_RDEV () {1;}' unless defined(&_STATBUF_ST_RDEV);
    eval 'sub _STATBUF_ST_NSEC () {1;}' unless defined(&_STATBUF_ST_NSEC);
    eval 'sub __S_IFMT () {0170000;}' unless defined(&__S_IFMT);
    eval 'sub __S_IFDIR () {0040000;}' unless defined(&__S_IFDIR);
    eval 'sub __S_IFCHR () {0020000;}' unless defined(&__S_IFCHR);
    eval 'sub __S_IFBLK () {0060000;}' unless defined(&__S_IFBLK);
    eval 'sub __S_IFREG () {0100000;}' unless defined(&__S_IFREG);
    eval 'sub __S_IFIFO () {0010000;}' unless defined(&__S_IFIFO);
    eval 'sub __S_IFLNK () {0120000;}' unless defined(&__S_IFLNK);
    eval 'sub __S_IFSOCK () {0140000;}' unless defined(&__S_IFSOCK);
    eval 'sub __S_TYPEISMQ {
        my($buf) = @_;
	    eval q((($buf)-> &st_mode - ($buf)-> &st_mode));
    }' unless defined(&__S_TYPEISMQ);
    eval 'sub __S_TYPEISSEM {
        my($buf) = @_;
	    eval q((($buf)-> &st_mode - ($buf)-> &st_mode));
    }' unless defined(&__S_TYPEISSEM);
    eval 'sub __S_TYPEISSHM {
        my($buf) = @_;
	    eval q((($buf)-> &st_mode - ($buf)-> &st_mode));
    }' unless defined(&__S_TYPEISSHM);
    eval 'sub __S_ISUID () {04000;}' unless defined(&__S_ISUID);
    eval 'sub __S_ISGID () {02000;}' unless defined(&__S_ISGID);
    eval 'sub __S_ISVTX () {01000;}' unless defined(&__S_ISVTX);
    eval 'sub __S_IREAD () {0400;}' unless defined(&__S_IREAD);
    eval 'sub __S_IWRITE () {0200;}' unless defined(&__S_IWRITE);
    eval 'sub __S_IEXEC () {0100;}' unless defined(&__S_IEXEC);
    if(defined(&__USE_ATFILE)) {
	eval 'sub UTIME_NOW () {((1 << 30) - 1);}' unless defined(&UTIME_NOW);
	eval 'sub UTIME_OMIT () {((1 << 30) - 2);}' unless defined(&UTIME_OMIT);
    }
}
1;
