require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_LINUX_MSDOS_FS_H)) {
    eval 'sub _LINUX_MSDOS_FS_H () {1;}' unless defined(&_LINUX_MSDOS_FS_H);
    require 'linux/types.ph';
    require 'linux/magic.ph';
    require 'asm/byteorder.ph';
    unless(defined(&SECTOR_SIZE)) {
	eval 'sub SECTOR_SIZE () {512;}' unless defined(&SECTOR_SIZE);
    }
    eval 'sub SECTOR_BITS () {9;}' unless defined(&SECTOR_BITS);
    eval 'sub MSDOS_DPB () {( &MSDOS_DPS);}' unless defined(&MSDOS_DPB);
    eval 'sub MSDOS_DPB_BITS () {4;}' unless defined(&MSDOS_DPB_BITS);
    eval 'sub MSDOS_DPS () {( &SECTOR_SIZE / $sizeof{\'struct msdos_dir_entry\'});}' unless defined(&MSDOS_DPS);
    eval 'sub MSDOS_DPS_BITS () {4;}' unless defined(&MSDOS_DPS_BITS);
    eval 'sub MSDOS_LONGNAME () {256;}' unless defined(&MSDOS_LONGNAME);
    eval 'sub CF_LE_W {
        my($v) = @_;
	    eval q( &le16_to_cpu($v));
    }' unless defined(&CF_LE_W);
    eval 'sub CF_LE_L {
        my($v) = @_;
	    eval q( &le32_to_cpu($v));
    }' unless defined(&CF_LE_L);
    eval 'sub CT_LE_W {
        my($v) = @_;
	    eval q( &cpu_to_le16($v));
    }' unless defined(&CT_LE_W);
    eval 'sub CT_LE_L {
        my($v) = @_;
	    eval q( &cpu_to_le32($v));
    }' unless defined(&CT_LE_L);
    eval 'sub MSDOS_ROOT_INO () {1;}' unless defined(&MSDOS_ROOT_INO);
    eval 'sub MSDOS_FSINFO_INO () {2;}' unless defined(&MSDOS_FSINFO_INO);
    eval 'sub MSDOS_DIR_BITS () {5;}' unless defined(&MSDOS_DIR_BITS);
    eval 'sub FAT_MAX_DIR_ENTRIES () {(65536);}' unless defined(&FAT_MAX_DIR_ENTRIES);
    eval 'sub FAT_MAX_DIR_SIZE () {( &FAT_MAX_DIR_ENTRIES <<  &MSDOS_DIR_BITS);}' unless defined(&FAT_MAX_DIR_SIZE);
    eval 'sub ATTR_NONE () {0;}' unless defined(&ATTR_NONE);
    eval 'sub ATTR_RO () {1;}' unless defined(&ATTR_RO);
    eval 'sub ATTR_HIDDEN () {2;}' unless defined(&ATTR_HIDDEN);
    eval 'sub ATTR_SYS () {4;}' unless defined(&ATTR_SYS);
    eval 'sub ATTR_VOLUME () {8;}' unless defined(&ATTR_VOLUME);
    eval 'sub ATTR_DIR () {16;}' unless defined(&ATTR_DIR);
    eval 'sub ATTR_ARCH () {32;}' unless defined(&ATTR_ARCH);
    eval 'sub ATTR_UNUSED () {( &ATTR_VOLUME |  &ATTR_ARCH |  &ATTR_SYS |  &ATTR_HIDDEN);}' unless defined(&ATTR_UNUSED);
    eval 'sub ATTR_EXT () {( &ATTR_RO |  &ATTR_HIDDEN |  &ATTR_SYS |  &ATTR_VOLUME);}' unless defined(&ATTR_EXT);
    eval 'sub CASE_LOWER_BASE () {8;}' unless defined(&CASE_LOWER_BASE);
    eval 'sub CASE_LOWER_EXT () {16;}' unless defined(&CASE_LOWER_EXT);
    eval 'sub DELETED_FLAG () {0xe5;}' unless defined(&DELETED_FLAG);
    eval 'sub IS_FREE {
        my($n) = @_;
	    eval q((!*($n) || *($n) ==  &DELETED_FLAG));
    }' unless defined(&IS_FREE);
    eval 'sub FAT_LFN_LEN () {255;}' unless defined(&FAT_LFN_LEN);
    eval 'sub MSDOS_NAME () {11;}' unless defined(&MSDOS_NAME);
    eval 'sub MSDOS_SLOTS () {21;}' unless defined(&MSDOS_SLOTS);
    eval 'sub MSDOS_DOT () {".	  ";}' unless defined(&MSDOS_DOT);
    eval 'sub MSDOS_DOTDOT () {"..	 ";}' unless defined(&MSDOS_DOTDOT);
    eval 'sub FAT_START_ENT () {2;}' unless defined(&FAT_START_ENT);
    eval 'sub MAX_FAT12 () {0xff4;}' unless defined(&MAX_FAT12);
    eval 'sub MAX_FAT16 () {0xfff4;}' unless defined(&MAX_FAT16);
    eval 'sub MAX_FAT32 () {0xffffff6;}' unless defined(&MAX_FAT32);
    eval 'sub BAD_FAT12 () {0xff7;}' unless defined(&BAD_FAT12);
    eval 'sub BAD_FAT16 () {0xfff7;}' unless defined(&BAD_FAT16);
    eval 'sub BAD_FAT32 () {0xffffff7;}' unless defined(&BAD_FAT32);
    eval 'sub EOF_FAT12 () {0xfff;}' unless defined(&EOF_FAT12);
    eval 'sub EOF_FAT16 () {0xffff;}' unless defined(&EOF_FAT16);
    eval 'sub EOF_FAT32 () {0xfffffff;}' unless defined(&EOF_FAT32);
    eval 'sub FAT_ENT_FREE () {(0);}' unless defined(&FAT_ENT_FREE);
    eval 'sub FAT_ENT_BAD () {( &BAD_FAT32);}' unless defined(&FAT_ENT_BAD);
    eval 'sub FAT_ENT_EOF () {( &EOF_FAT32);}' unless defined(&FAT_ENT_EOF);
    eval 'sub FAT_FSINFO_SIG1 () {0x41615252;}' unless defined(&FAT_FSINFO_SIG1);
    eval 'sub FAT_FSINFO_SIG2 () {0x61417272;}' unless defined(&FAT_FSINFO_SIG2);
    eval 'sub IS_FSINFO {
        my($x) = @_;
	    eval q(( &le32_to_cpu(($x)-> &signature1) ==  &FAT_FSINFO_SIG1  &&  &le32_to_cpu(($x)-> &signature2) ==  &FAT_FSINFO_SIG2));
    }' unless defined(&IS_FSINFO);
    eval 'sub FAT_STATE_DIRTY () {0x1;}' unless defined(&FAT_STATE_DIRTY);
    eval 'sub VFAT_IOCTL_READDIR_BOTH () { &_IOR(ord(\'r\'), 1, \'struct __fat_dirent\'[2]);}' unless defined(&VFAT_IOCTL_READDIR_BOTH);
    eval 'sub VFAT_IOCTL_READDIR_SHORT () { &_IOR(ord(\'r\'), 2, \'struct __fat_dirent\'[2]);}' unless defined(&VFAT_IOCTL_READDIR_SHORT);
    eval 'sub FAT_IOCTL_GET_ATTRIBUTES () { &_IOR(ord(\'r\'), 0x10,  &__u32);}' unless defined(&FAT_IOCTL_GET_ATTRIBUTES);
    eval 'sub FAT_IOCTL_SET_ATTRIBUTES () { &_IOW(ord(\'r\'), 0x11,  &__u32);}' unless defined(&FAT_IOCTL_SET_ATTRIBUTES);
    eval 'sub FAT_IOCTL_GET_VOLUME_ID () { &_IOR(ord(\'r\'), 0x13,  &__u32);}' unless defined(&FAT_IOCTL_GET_VOLUME_ID);
}
1;
