require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_LINUX_TLS_H)) {
    eval 'sub _LINUX_TLS_H () {1;}' unless defined(&_LINUX_TLS_H);
    require 'linux/types.ph';
    eval 'sub TLS_TX () {1;}' unless defined(&TLS_TX);
    eval 'sub TLS_RX () {2;}' unless defined(&TLS_RX);
    eval 'sub TLS_VERSION_MINOR {
        my($ver) = @_;
	    eval q((($ver) & 0xff));
    }' unless defined(&TLS_VERSION_MINOR);
    eval 'sub TLS_VERSION_MAJOR {
        my($ver) = @_;
	    eval q(((($ver) >> 8) & 0xff));
    }' unless defined(&TLS_VERSION_MAJOR);
    eval 'sub TLS_VERSION_NUMBER {
        my($id) = @_;
	    eval q((((($id &_VERSION_MAJOR) & 0xff) << 8) | (($id &_VERSION_MINOR) & 0xff)));
    }' unless defined(&TLS_VERSION_NUMBER);
    eval 'sub TLS_1_2_VERSION_MAJOR () {0x3;}' unless defined(&TLS_1_2_VERSION_MAJOR);
    eval 'sub TLS_1_2_VERSION_MINOR () {0x3;}' unless defined(&TLS_1_2_VERSION_MINOR);
    eval 'sub TLS_1_2_VERSION () { &TLS_VERSION_NUMBER( &TLS_1_2);}' unless defined(&TLS_1_2_VERSION);
    eval 'sub TLS_1_3_VERSION_MAJOR () {0x3;}' unless defined(&TLS_1_3_VERSION_MAJOR);
    eval 'sub TLS_1_3_VERSION_MINOR () {0x4;}' unless defined(&TLS_1_3_VERSION_MINOR);
    eval 'sub TLS_1_3_VERSION () { &TLS_VERSION_NUMBER( &TLS_1_3);}' unless defined(&TLS_1_3_VERSION);
    eval 'sub TLS_CIPHER_AES_GCM_128 () {51;}' unless defined(&TLS_CIPHER_AES_GCM_128);
    eval 'sub TLS_CIPHER_AES_GCM_128_IV_SIZE () {8;}' unless defined(&TLS_CIPHER_AES_GCM_128_IV_SIZE);
    eval 'sub TLS_CIPHER_AES_GCM_128_KEY_SIZE () {16;}' unless defined(&TLS_CIPHER_AES_GCM_128_KEY_SIZE);
    eval 'sub TLS_CIPHER_AES_GCM_128_SALT_SIZE () {4;}' unless defined(&TLS_CIPHER_AES_GCM_128_SALT_SIZE);
    eval 'sub TLS_CIPHER_AES_GCM_128_TAG_SIZE () {16;}' unless defined(&TLS_CIPHER_AES_GCM_128_TAG_SIZE);
    eval 'sub TLS_CIPHER_AES_GCM_128_REC_SEQ_SIZE () {8;}' unless defined(&TLS_CIPHER_AES_GCM_128_REC_SEQ_SIZE);
    eval 'sub TLS_CIPHER_AES_GCM_256 () {52;}' unless defined(&TLS_CIPHER_AES_GCM_256);
    eval 'sub TLS_CIPHER_AES_GCM_256_IV_SIZE () {8;}' unless defined(&TLS_CIPHER_AES_GCM_256_IV_SIZE);
    eval 'sub TLS_CIPHER_AES_GCM_256_KEY_SIZE () {32;}' unless defined(&TLS_CIPHER_AES_GCM_256_KEY_SIZE);
    eval 'sub TLS_CIPHER_AES_GCM_256_SALT_SIZE () {4;}' unless defined(&TLS_CIPHER_AES_GCM_256_SALT_SIZE);
    eval 'sub TLS_CIPHER_AES_GCM_256_TAG_SIZE () {16;}' unless defined(&TLS_CIPHER_AES_GCM_256_TAG_SIZE);
    eval 'sub TLS_CIPHER_AES_GCM_256_REC_SEQ_SIZE () {8;}' unless defined(&TLS_CIPHER_AES_GCM_256_REC_SEQ_SIZE);
    eval 'sub TLS_CIPHER_AES_CCM_128 () {53;}' unless defined(&TLS_CIPHER_AES_CCM_128);
    eval 'sub TLS_CIPHER_AES_CCM_128_IV_SIZE () {8;}' unless defined(&TLS_CIPHER_AES_CCM_128_IV_SIZE);
    eval 'sub TLS_CIPHER_AES_CCM_128_KEY_SIZE () {16;}' unless defined(&TLS_CIPHER_AES_CCM_128_KEY_SIZE);
    eval 'sub TLS_CIPHER_AES_CCM_128_SALT_SIZE () {4;}' unless defined(&TLS_CIPHER_AES_CCM_128_SALT_SIZE);
    eval 'sub TLS_CIPHER_AES_CCM_128_TAG_SIZE () {16;}' unless defined(&TLS_CIPHER_AES_CCM_128_TAG_SIZE);
    eval 'sub TLS_CIPHER_AES_CCM_128_REC_SEQ_SIZE () {8;}' unless defined(&TLS_CIPHER_AES_CCM_128_REC_SEQ_SIZE);
    eval 'sub TLS_SET_RECORD_TYPE () {1;}' unless defined(&TLS_SET_RECORD_TYPE);
    eval 'sub TLS_GET_RECORD_TYPE () {2;}' unless defined(&TLS_GET_RECORD_TYPE);
}
1;
