require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_LINUX_VHOST_H)) {
    eval 'sub _LINUX_VHOST_H () {1;}' unless defined(&_LINUX_VHOST_H);
    require 'linux/vhost_types.ph';
    require 'linux/types.ph';
    require 'linux/ioctl.ph';
    eval 'sub VHOST_VIRTIO () {0xaf;}' unless defined(&VHOST_VIRTIO);
    eval 'sub VHOST_GET_FEATURES () { &_IOR( &VHOST_VIRTIO, 0x,  &__u64);}' unless defined(&VHOST_GET_FEATURES);
    eval 'sub VHOST_SET_FEATURES () { &_IOW( &VHOST_VIRTIO, 0x,  &__u64);}' unless defined(&VHOST_SET_FEATURES);
    eval 'sub VHOST_SET_OWNER () { &_IO( &VHOST_VIRTIO, 0x1);}' unless defined(&VHOST_SET_OWNER);
    eval 'sub VHOST_RESET_OWNER () { &_IO( &VHOST_VIRTIO, 0x2);}' unless defined(&VHOST_RESET_OWNER);
    eval 'sub VHOST_SET_MEM_TABLE () { &_IOW( &VHOST_VIRTIO, 0x3, \'struct vhost_memory\');}' unless defined(&VHOST_SET_MEM_TABLE);
    eval 'sub VHOST_SET_LOG_BASE () { &_IOW( &VHOST_VIRTIO, 0x4,  &__u64);}' unless defined(&VHOST_SET_LOG_BASE);
    eval 'sub VHOST_SET_LOG_FD () { &_IOW( &VHOST_VIRTIO, 0x7, \'int\');}' unless defined(&VHOST_SET_LOG_FD);
    eval 'sub VHOST_SET_VRING_NUM () { &_IOW( &VHOST_VIRTIO, 0x10, \'struct vhost_vring_state\');}' unless defined(&VHOST_SET_VRING_NUM);
    eval 'sub VHOST_SET_VRING_ADDR () { &_IOW( &VHOST_VIRTIO, 0x11, \'struct vhost_vring_addr\');}' unless defined(&VHOST_SET_VRING_ADDR);
    eval 'sub VHOST_SET_VRING_BASE () { &_IOW( &VHOST_VIRTIO, 0x12, \'struct vhost_vring_state\');}' unless defined(&VHOST_SET_VRING_BASE);
    eval 'sub VHOST_GET_VRING_BASE () { &_IOWR( &VHOST_VIRTIO, 0x12, \'struct vhost_vring_state\');}' unless defined(&VHOST_GET_VRING_BASE);
    eval 'sub VHOST_VRING_LITTLE_ENDIAN () {0;}' unless defined(&VHOST_VRING_LITTLE_ENDIAN);
    eval 'sub VHOST_VRING_BIG_ENDIAN () {1;}' unless defined(&VHOST_VRING_BIG_ENDIAN);
    eval 'sub VHOST_SET_VRING_ENDIAN () { &_IOW( &VHOST_VIRTIO, 0x13, \'struct vhost_vring_state\');}' unless defined(&VHOST_SET_VRING_ENDIAN);
    eval 'sub VHOST_GET_VRING_ENDIAN () { &_IOW( &VHOST_VIRTIO, 0x14, \'struct vhost_vring_state\');}' unless defined(&VHOST_GET_VRING_ENDIAN);
    eval 'sub VHOST_SET_VRING_KICK () { &_IOW( &VHOST_VIRTIO, 0x20, \'struct vhost_vring_file\');}' unless defined(&VHOST_SET_VRING_KICK);
    eval 'sub VHOST_SET_VRING_CALL () { &_IOW( &VHOST_VIRTIO, 0x21, \'struct vhost_vring_file\');}' unless defined(&VHOST_SET_VRING_CALL);
    eval 'sub VHOST_SET_VRING_ERR () { &_IOW( &VHOST_VIRTIO, 0x22, \'struct vhost_vring_file\');}' unless defined(&VHOST_SET_VRING_ERR);
    eval 'sub VHOST_SET_VRING_BUSYLOOP_TIMEOUT () { &_IOW( &VHOST_VIRTIO, 0x23, \'struct vhost_vring_state\');}' unless defined(&VHOST_SET_VRING_BUSYLOOP_TIMEOUT);
    eval 'sub VHOST_GET_VRING_BUSYLOOP_TIMEOUT () { &_IOW( &VHOST_VIRTIO, 0x24, \'struct vhost_vring_state\');}' unless defined(&VHOST_GET_VRING_BUSYLOOP_TIMEOUT);
    eval 'sub VHOST_BACKEND_F_IOTLB_MSG_V2 () {0x1;}' unless defined(&VHOST_BACKEND_F_IOTLB_MSG_V2);
    eval 'sub VHOST_SET_BACKEND_FEATURES () { &_IOW( &VHOST_VIRTIO, 0x25,  &__u64);}' unless defined(&VHOST_SET_BACKEND_FEATURES);
    eval 'sub VHOST_GET_BACKEND_FEATURES () { &_IOR( &VHOST_VIRTIO, 0x26,  &__u64);}' unless defined(&VHOST_GET_BACKEND_FEATURES);
    eval 'sub VHOST_NET_SET_BACKEND () { &_IOW( &VHOST_VIRTIO, 0x30, \'struct vhost_vring_file\');}' unless defined(&VHOST_NET_SET_BACKEND);
    eval 'sub VHOST_SCSI_SET_ENDPOINT () { &_IOW( &VHOST_VIRTIO, 0x40, \'struct vhost_scsi_target\');}' unless defined(&VHOST_SCSI_SET_ENDPOINT);
    eval 'sub VHOST_SCSI_CLEAR_ENDPOINT () { &_IOW( &VHOST_VIRTIO, 0x41, \'struct vhost_scsi_target\');}' unless defined(&VHOST_SCSI_CLEAR_ENDPOINT);
    eval 'sub VHOST_SCSI_GET_ABI_VERSION () { &_IOW( &VHOST_VIRTIO, 0x42, \'int\');}' unless defined(&VHOST_SCSI_GET_ABI_VERSION);
    eval 'sub VHOST_SCSI_SET_EVENTS_MISSED () { &_IOW( &VHOST_VIRTIO, 0x43,  &__u32);}' unless defined(&VHOST_SCSI_SET_EVENTS_MISSED);
    eval 'sub VHOST_SCSI_GET_EVENTS_MISSED () { &_IOW( &VHOST_VIRTIO, 0x44,  &__u32);}' unless defined(&VHOST_SCSI_GET_EVENTS_MISSED);
    eval 'sub VHOST_VSOCK_SET_GUEST_CID () { &_IOW( &VHOST_VIRTIO, 0x60,  &__u64);}' unless defined(&VHOST_VSOCK_SET_GUEST_CID);
    eval 'sub VHOST_VSOCK_SET_RUNNING () { &_IOW( &VHOST_VIRTIO, 0x61, \'int\');}' unless defined(&VHOST_VSOCK_SET_RUNNING);
}
1;
